#!/bin/sh


#mdecore@tarsier:~ > perso/fingall mdecore
#localhost : console
#saturne.c-s.fr
#mdecore@tarsier:~ >

[ $# -ne 1 -a $# -ne 2 ] && echo >&2 "Usage : `basename $0` <logname> [timeout]" && exit 1
[ $# -eq 2 ] && TimeOut=$2 || TimeOut=3

exec 2> /dev/null

for machine in `cat ~/.diffusion`
do
    (rsh $machine w $1 | grep $1 | awk '{print $3}' | uniq > /tmp/fingall.$$) &
    pid=$!
    sleep $TimeOut
    kill $pid
    [ -s /tmp/fingall.$$ ] && echo "$machine : `cat /tmp/fingall.$$`"
done

rm -f /tmp/fingall.$$

exit 0
