#!/bin/sh

# Affichie la premiere des machines dans la liste sur laquelle la personne est loguee, recommence tt les 60 s si pas trouve, ou quitte avec 0 si trouv.

[ $# -gt 5 -o $# -lt 1 ] && echo >&2 "Usage : `basename $0` <logname> [-t <timeout>] [-d <delay>]" && exit 1

while [ -n "$1" ]
do
    case "$1" in
        -t) TimeOut="$2" ; shift ;;
        -d) Delay="$2" ; shift ;;
        *)  Nom="$1" ;;
    esac
    shift
done

exec 2> /dev/null

LOGTO=$LOGNAME

[ -z "$Delay" ] && Delay=60
[ -z "$TimeOut" ] && TimeOut=3

trap 'rm -f ~/.tla$$ ; exit 0' INT ABRT KILL
rm -f ~/.tla*

echo 0 > ~/.tla$$  

while true
do
    for machine in `cat ~/.diffusion`
    do
        [ -f ~/.tla$$ ] && [ `cat ~/.tla$$` -eq 1 ] && exit 0
        retour=`finger $Nom@$machine | grep "On since"`

        if [ -n "$retour" ] #&& [ `cat ~/.tla$$` -eq 0 ]
        then

            echo 1 > ~/.tla$$
            Nom_fing=`finger $Nom@$machine | grep "Name:" | sed -e 's/.*Name: //g'`
            idle="finger $Nom@$machine | grep idle | \
                  sed -e 's/.*idle \(.*\), from.*/\1/g' | sort -rn | tail -n 1"
            retour=`eval $idle`
            if ! echo $retour | grep days > /dev/null
            then
                mail -s "[tla] $Nom_fing logu" $LOGTO << FIN
Vite ! $Nom_fing vient de se loguer sur $machine ($retour) !

`date`

`finger $Nom@$machine`
FIN
            fi
        fi
    done

    sleep $Delay
done
