#!/bin/sh

#[ $# -ne 1 -a $# -ne 2 ] && echo >&2 "Usage : `basename $0` <logname> [timeout]" && exit 1
#[ $# -eq 2 ] && TimeOut=$2 || TimeOut=3

# Affichie la premiere des machines dans la liste sur laquelle la personne est loguee, recommence tt les 60 s si pas trouve, ou quitte avec 0 si trouv.

[ $# -gt 5 -o $# -lt 1 ] && echo >&2 "Usage : `basename $0` <logname> [-t <timeout>] [-d <delay>]" && exit 1

while [ -n "$1" ]
do
    case "$1" in
        -t) TimeOut="$2" ; shift ;;
        -d) Delay="$2" ; shift ;;
        *)  Nom="$1" ;;
    esac
    shift
done

exec 2> /dev/null

[ -z "$Delay" ] && Delay=60
[ -z "$TimeOut" ] && TimeOut=3

LOGTO=$LOGNAME

trap 'rm -f ~/.tou$$ /tmp/tou.$$ ; exit 0' INT ABRT KILL

echo 0 > ~/.tou$$

while true
do
    for machine in `cat ~/.diffusion`
    do
        [ -f ~/.tou$$ ] && [ `cat ~/.tou$$` -eq 1 ] && exit 0
        (
        rsh $machine "ps aux | grep \"^$Nom\" | egrep -v \"ps aux|grep \^$Nom|egrep\"" > /tmp/tou.$$
        ) &
        pid=$!
        sleep $TimeOut
        kill $pid

        if [ -s /tmp/tou.$$ ] && [ `cat ~/.tou$$` -eq 0 ]
        then
            echo 1 > ~/.tou$$
            mail -s "[tou] $Nom logu" $LOGTO << FIN
Vite ! $Nom vient de se loguer sur $machine !

`date`

`cat /tmp/tou.$$`
FIN
        fi
    done

    sleep $Delay
done

rm -f ~/.tou$$ /tmp/tou.$$

exit 0
