.TH TLA.SH 1 "Sep 12 2002"

.SH NAME
tla.sh, estula.sh, tou.sh - affiche la machine sur laquelle est
connecte un utilisateur

.SH USAGE

\fBtla.sh\fP \fIlogname\fP [-t \fItimeout\fP] [-d \fIdelay\fP]

\fBestula.sh\fP \fIlogname\fP [-t \fItimeout\fP] [-d \fIdelay\fP]

\fBtou.sh\fP \fIlogname\fP [-t \fItimeout\fP] [-d \fIdelay\fP]

.SH DESCRIPTION

Chacun de ces programmes execute sur un ensemble de
machines definies dans le fichier \fB~/.diffusion\fP une commande cherchant
l'utilisateur \fIlogname\fP. Si la personne est connectee, un mail est envoye
a l'utilisateur dont le nom est contenu dans la variable d'environnement
LOGNAME et le programme se termine. Sinon une autre verification est
a nouveau effectuee apres un delai de \fIdelay\fP (60 secondes par defaut).
Une valeur de timeout peut etre passee au programme pour donner le temps
de repondre aux serveurs distant. Par defaut cette valeur est de 3 secondes.

.SH PROGRAMMES

Les programmes cherchant un utilisateur sont les suivants :
.TP 20
.I tla.sh
finger \fBlogname\fP@host
.TP 20
.I estula.sh
rsh host finger \fBlogname\fP
.TP 20
.I tou.sh
rsh ps aux | grep \fBlogname\fP
.LP
Historiquement, j'ai ecrit d'abord \fBtla.sh\fP, qui ne marchait pas si le
port de finger etait ferme, ce qui est habituellement le cas pour des
raisons de securite. Ensuite j'ai ecrit \fBestula.sh\fP, qui est utilise rsh,
mais si l'utilisateur a un fichier .nofinger cette commande ne fonctionne
pas. La commande \fBtou.sh\fP regle le probleme en cherchant les processus
lances par l'utilisateur recherche.

.SH FICHIERS

~/.diffusion : contient la liste des machines sur lesquelles il faut
chercher l'utilisateur

.SH REQUIERE

finger, rsh, mail

.SH VARIABLES

.TP 20
.I LOGNAME
nom de l'utilisateur a qui il faut envoyer par mel le
resultat de la commande
.LP
.SH AUTEUR

Mathieu DECORE \fB<mdecore@linux-france.org>\fP. Merci d'envoyer toute correction,
suggestion, critique, insulte a cette adresse.

